=== modified file 'lib/lp/bugs/javascript/filebug_dupefinder.js'
--- lib/lp/bugs/javascript/filebug_dupefinder.js	2011-04-19 15:10:57 +0000
+++ lib/lp/bugs/javascript/filebug_dupefinder.js	2011-04-25 14:07:13 +0000
@@ -12,9 +12,7 @@
     DISPLAY = 'display',
     EXPANDER_COLLAPSED = '/@@/treeCollapsed',
     EXPANDER_EXPANDED = '/@@/treeExpanded',
-    INLINE = 'inline',
     INNER_HTML = 'innerHTML',
-    LAZR_CLOSED = 'lazr-closed',
     NONE = 'none',
     SRC = 'src',
     UNSEEN = 'unseen';
@@ -22,6 +20,10 @@
 var namespace = Y.namespace('lp.bugs.filebug_dupefinder');
 
 /*
+ * The IO provider to use. A stub may be used for testing.
+ */    
+var YIO = Y;
+/*
  * The NodeList of possible duplicates.
  */
 var bug_already_reported_expanders;
@@ -238,7 +240,7 @@
     form_fade_out.on('end', function() {
         var config = {on: {success: on_success,
                        failure: show_failure_message}};
-        Y.io(search_url, config);
+        YIO.io(search_url, config);
     });
     form_fade_out.run();
 }
@@ -364,7 +366,7 @@
 
     set_product_urls();
     // Reload the filebug form.
-    Y.io(filebug_form_url, config);
+    YIO.io(filebug_form_url, config);
 }
 
 /**
@@ -398,7 +400,7 @@
     search_button.set('value', 'Next');
 
     // Set up the handler for the search form.
-    search_form = Y.one('#filebug-search-form');
+    var search_form = Y.one('#filebug-search-form');
     search_form.on('submit', function(e) {
         // Prevent the event from propagating; we don't want to reload
         // the page.
@@ -515,11 +517,21 @@
         if (Y.Lang.isValue(filebug_form_url_element)) {
             filebug_form_url = filebug_form_url_element.getAttribute(
                 'href');
-            Y.io(filebug_form_url, config);
+            YIO.io(filebug_form_url, config);
         }
     });
 };
 
+/**
+ * Set up and configure the module.
+ */
+ namespace.setup_config = function(config) {
+    if (config.yio !== undefined) {
+        //We can be given an alternative IO provider for use in tests.
+        YIO = config.yio;
+    }
+};
+
 }, "0.1", {"requires": [
     "base", "io", "oop", "node", "event", "lazr.formoverlay",
     "lazr.effects"]});

=== added file 'lib/lp/bugs/javascript/tests/test_filebug_dupfinder.html'
--- lib/lp/bugs/javascript/tests/test_filebug_dupfinder.html	1970-01-01 00:00:00 +0000
+++ lib/lp/bugs/javascript/tests/test_filebug_dupfinder.html	2011-04-25 14:07:13 +0000
@@ -0,0 +1,75 @@
+<html>
+<head>
+    <title>File bug functionality</title>
+
+    <!-- YUI 3.0 Setup -->
+    <script type="text/javascript"
+            src="../../../../canonical/launchpad/icing/yui/yui/yui.js"></script>
+    <script type="text/javascript"
+            src="../../../../canonical/launchpad/icing/lazr/build/lazr.js"></script>
+    <link rel="stylesheet"
+          href="../../../../canonical/launchpad/icing/yui/cssreset/reset.css"/>
+    <link rel="stylesheet"
+          href="../../../../canonical/launchpad/icing/yui/cssfonts/fonts.css"/>
+    <link rel="stylesheet"
+          href="../../../../canonical/launchpad/icing/yui/cssbase/base.css"/>
+    <link rel="stylesheet"
+          href="../../../../canonical/launchpad/javascript/test.css" />
+
+    <script type="text/javascript"
+            src="../../../app/javascript/client.js"></script>
+    <script type="text/javascript"
+            src="../../../app/javascript/errors.js"></script>
+
+    <!-- The module under test -->
+    <script type="text/javascript"
+            src="../filebug_dupefinder.js"></script>
+
+    <!-- The test suite -->
+    <script type="text/javascript"
+            src="test_filebug_dupfinder.js"></script>
+
+    <!-- Pretty up the sample html -->
+    <style type="text/css">
+        div#sample {margin:15px; width:200px; border:1px solid #999; padding:10px;}
+    </style>
+</head>
+<body class="yui3-skin-sam">
+<!-- Example markup required by test suite -->
+<div id="test-root">
+    <form id="filebug-search-form" enctype="multipart/form-data"
+          method="post" action="#">
+    <table>
+        <tr>
+            <td>
+                <div>
+                    <label for="field.title">Summary:</label>
+                    <input type="text" value="" size="40" name="field.title" id="field.title">
+                </div>
+            </td>
+            <td>
+                <input type="submit" class="button" value="Next" name="field.actions.search" id="field.actions.search">
+            </td>
+        </tr>
+    </table>
+    </form>    
+    <div style="opacity: 0; display: none" class="transparent" id="filebug-form-container">
+        <div id="bug_reporting_form">
+            <div>
+                <form id="filebug-form" method="post" action="#">
+                    <div class="actions">
+                        <input type="submit" class="button" value="Submit Bug Report" name="field.actions.submit_bug" id="field.actions.submit_bug">
+                    </div>
+                </form>
+            </div>
+        </div>
+    </div>
+    <a id="filebug-base-url" href="https://bugs.launchpad.dev/"></a>
+    <a id="filebug-form-url" href="https://bugs.launchpad.dev/firefox/+filebug-inline-form"></a>
+    <a id="duplicate-search-url" href="https://bugs.launchpad.dev/firefox/+filebug-show-similar"></a>
+</div>
+
+<!-- The test output -->
+<div id="log"></div>
+</body>
+</html>

=== added file 'lib/lp/bugs/javascript/tests/test_filebug_dupfinder.js'
--- lib/lp/bugs/javascript/tests/test_filebug_dupfinder.js	1970-01-01 00:00:00 +0000
+++ lib/lp/bugs/javascript/tests/test_filebug_dupfinder.js	2011-04-25 14:07:13 +0000
@@ -0,0 +1,69 @@
+YUI({
+    base: '../../../../canonical/launchpad/icing/yui/',
+    filter: 'raw', combine: false, fetchCSS: false
+    }).use('test', 'console', 'lp.bugs.filebug_dupefinder',
+        'node-event-simulate', function(Y) {
+
+var suite = new Y.Test.Suite("lp.bugs.filebug_dupefinder Tests");
+var module = Y.lp.bugs.filebug_dupefinder;
+
+/*
+ * A wrapper for the Y.Event.simulate() function.  The wrapper accepts
+ * CSS selectors and Node instances instead of raw nodes.
+ */
+function simulate(widget, selector, evtype, options) {
+    var node_to_use = widget;
+    if (selector !== undefined)
+        node_to_use = widget.one(selector);
+    var rawnode = Y.Node.getDOMNode(node_to_use);
+    Y.Event.simulate(rawnode, evtype, options);
+}
+
+function IOStub(){
+    if (!(this instanceof IOStub)) {
+        throw new Error("Constructor called as a function");
+    }
+    this.io = function(url, config) {
+        this._call('io', config, arguments);
+    };
+}
+
+IOStub.prototype._call = function(name, config, args) {
+    config.on.success(0, '', {});
+};
+
+suite.add(new Y.Test.Case({
+    name: 'Test filebug form manipulation.',
+
+    setUp: function() {
+        var config = {};
+        config.yio = new IOStub();
+        module.setup_config(config);
+        module.setup_dupe_finder();
+    },
+
+    tearDown: function() {
+    },
+
+    test_search_shows_filebug_form: function() {
+        var search_button = Y.one(Y.DOM.byId('field.actions.search'));
+        simulate(search_button, undefined, 'click');
+    }
+
+}));
+
+var handle_complete = function(data) {
+    status_node = Y.Node.create(
+        '<p id="complete">Test status: complete</p>');
+    Y.one('body').appendChild(status_node);
+    };
+Y.Test.Runner.on('complete', handle_complete);
+Y.Test.Runner.add(suite);
+
+var console = new Y.Console({newestOnTop: false});
+console.render('#log');
+
+Y.on('domready', function() {
+    Y.Test.Runner.run();
+});
+});

